(function() {
  var activate, onClose, onSelect, save, template;

  template = function() {
    return $('<input />').attr('type', 'text');
  };

  save = function(datetimepickerElement, dateTimeText, additionalDoneEvent) {
    var cmsField, datetime;
    cmsField = datetimepickerElement.data('cmsField');
    datetime = datetimepickerElement.scrivito_datetimepicker('getDate');
    return cmsField.scrivito('save', datetime).done(function() {
      cmsField.trigger('scrivito_editors:save');
      if (additionalDoneEvent) {
        return cmsField.trigger(additionalDoneEvent);
      }
    });
  };

  onClose = function(dateTimeText) {
    return save($(this), dateTimeText, 'scrivito_editors:blur');
  };

  onSelect = function(dateTimeText) {
    return save($(this), dateTimeText);
  };

  activate = function(element) {
    var cmsField;
    cmsField = $(element);
    scrivito.editors.applyPlaceholder(cmsField);
    return cmsField.on('click', function(event) {
      var content, dateFormat, options, timeFormat;
      if (cmsField.is('.hasDatepicker')) {
        return;
      }
      event.preventDefault();
      content = cmsField.text().trim();
      dateFormat = cmsField.data('scrivitoEditorsDateFormat');
      timeFormat = cmsField.data('scrivitoEditorsTimeFormat');
      options = {
        onClose: onClose,
        onSelect: onSelect
      };
      options.dateFormat = dateFormat || 'yy-mm-dd';
      if (timeFormat) {
        options.timeFormat = timeFormat;
      }
      template().data('cmsField', cmsField).insertAfter(cmsField).scrivito_datetimepicker(options).scrivito_datetimepicker('setDate', $(cmsField).scrivito('content')).focus();
      return cmsField.hide();
    });
  };

  scrivito.editors.date_editor = {
    can_edit: function(element) {
      return $(element).is('[data-scrivito-field-type=date]');
    },
    activate: function(element) {
      return activate(element);
    }
  };

  scrivito.on('load', function() {
    return scrivito.define_editor('date', scrivito.editors.date_editor);
  });

}).call(this);
