(function() {
  var COEXISTING_EDITORS, PRIMARY_EDITORS, default_editor;

  PRIMARY_EDITORS = ['date_editor', 'enum_editor', 'html_editor', 'image_editor', 'link_editor', 'linklist_editor', 'multienum_editor', 'number_editor', 'permalink_editor', 'reference_editor', 'referencelist_editor', 'string_editor', 'stringlist_editor'];

  COEXISTING_EDITORS = ['binary_editor'];

  default_editor = {
    can_edit: function() {
      return true;
    },
    activate: function(element) {
      var editor, i, j, len, len1;
      for (i = 0, len = COEXISTING_EDITORS.length; i < len; i++) {
        editor = COEXISTING_EDITORS[i];
        if (scrivito.editors[editor].can_edit(element)) {
          scrivito.editors[editor].activate(element);
        }
      }
      for (j = 0, len1 = PRIMARY_EDITORS.length; j < len1; j++) {
        editor = PRIMARY_EDITORS[j];
        if (scrivito.editors[editor].can_edit(element)) {
          scrivito.editors[editor].activate(element);
          return;
        }
      }
    }
  };

  scrivito.on('load', function() {
    return scrivito.define_editor('default', default_editor);
  });

}).call(this);
