(function() {
  var extendDeepData, mergeFilterContexts,
    hasProp = {}.hasOwnProperty;

  extendDeepData = function(data, prefix) {
    var i, key, len, name, obj, obj1, path, ref, results, value;
    results = [];
    for (key in data) {
      if (!hasProp.call(data, key)) continue;
      value = data[key];
      if (!(key.search(prefix) === 0)) {
        continue;
      }
      path = key.match(RegExp("([A-Z]|^" + prefix + ")[^A-Z]*", "g"));
      if (path[0] === prefix) {
        ref = path.slice(1).reverse();
        for (i = 0, len = ref.length; i < len; i++) {
          name = ref[i];
          value = (
            obj = {},
            obj["" + (name.toLowerCase())] = value,
            obj
          );
        }
        results.push($.extend(true, data, (
          obj1 = {},
          obj1["" + prefix] = value,
          obj1
        )));
      } else {
        results.push(void 0);
      }
    }
    return results;
  };

  mergeFilterContexts = function() {
    var cmsFields;
    cmsFields = $("[data-scrivito-field-type][data-scrivito-editors-filter-context],\n[data-scrivito-field-type^=\"html\"],\n[data-scrivito-field-type^=\"link\"],\n[data-scrivito-field-type^=\"reference\"]");
    return cmsFields.each(function() {
      var cmsField, data;
      cmsField = $(this);
      data = cmsField.data();
      return extendDeepData(data, 'scrivitoEditorsFilterContext');
    });
  };

  scrivito.on('content', function() {
    if (scrivito.in_editable_view()) {
      return mergeFilterContexts();
    }
  });

}).call(this);
