(function() {
  var DEFAULT_TARGETS, setTarget, targets, toggleTargetSelection;

  DEFAULT_TARGETS = {
    _blank: "new window",
    _top: "top-level window",
    "": "same container"
  };

  scrivito.editors._linkTargetEditing = {
    activate: function(cmsField, listElement, link) {
      var label, ref, target;
      listElement.on('click', '[data-scrivito-editors-toggle-target]', function() {
        return toggleTargetSelection(listElement);
      }).on('click', '[data-target-option]', function() {
        setTarget(cmsField, listElement, $(this).attr("data-target-option"));
        toggleTargetSelection(listElement);
        return cmsField.trigger('scrivito_editors_private:target_changed');
      });
      ref = targets(cmsField);
      for (target in ref) {
        label = ref[target];
        $("<li data-scrivito-editors-set-target>" + label + "</li>").appendTo(listElement.find(".dropdown_menu")).attr("data-target-option", target);
      }
      return setTarget(cmsField, listElement, link.target);
    }
  };

  setTarget = function(cmsField, listElement, target) {
    var text;
    listElement.attr("data-target", target);
    text = targets(cmsField)[target] || target;
    if (target === "") {
      text = "";
    }
    listElement.find(".scrivito_editors_current_target").text(text);
    return false;
  };

  toggleTargetSelection = function(listElement) {
    listElement.find('.dropdown_menu').slideToggle();
    return false;
  };

  targets = function(cmsField) {
    return cmsField.data('scrivito_editors_link_targets') || DEFAULT_TARGETS;
  };

}).call(this);
