(function() {
  if (this.RedactorPlugins == null) {
    this.RedactorPlugins = {};
  }

  RedactorPlugins.scrivito_editors_link_manager = function() {
    var self;
    return self = {
      init: function() {
        this.modal.addTemplate('scrivito_link_manager_browse', self.browseButtonHtml);
        this.modal.addCallback('imageEdit', self.addBrowseToModal);
        return this.modal.addCallback('link', self.addBrowseToModal);
      },
      browseButtonHtml: "<button class=\"editing-button editing-green\">\n  <i class=\"editing-icon editing-icon-search\"></i>\n  Browse\n</button>",
      urlInput: function() {
        return this.modal.getModal().find('#redactor-link-url, #redactor-image-link');
      },
      addBrowseToModal: function() {
        return self.urlInput().wrap('<div id="scrivito-link-manager-url"></div>').after(this.modal.getTemplate('scrivito_link_manager_browse')).siblings('button').on('click', self.browse);
      },
      browse: function() {
        return scrivito.content_browser.open({
          filter: this.$element.data('scrivitoEditorsFilter'),
          filter_context: this.$element.data('scrivitoEditorsFilterContext'),
          selection: self.getObjIds(),
          selection_mode: 'single'
        }).done((function(_this) {
          return function(selection) {
            var id;
            id = selection[0];
            if (id != null) {
              return self.setObjId(id);
            }
          };
        })(this));
      },
      getObjIds: function() {
        var id;
        if (id = scrivito.id_from_path(self.urlInput().val())) {
          return [id];
        } else {
          return [];
        }
      },
      setObjId: function(id) {
        return self.urlInput().val(scrivito.path_for_id(id));
      }
    };
  };

}).call(this);
